#!/usr/bin/perl -w
#
# Badminton Manager
# (c) 2003 Ruedi Hofer
#
# $Date: 2004/03/21 14:34:36 $ , $Revision: 1.23 $
#

use Fcntl ':flock'; 
use CGI qw(:standard :html3);
use Mail::Mailer; 
require 'config.pl';

print header({-pragma=>NOCACHE}),start_html(-style=>{'src'=>'/homepage/common/stylesheet.css'},-title=>'Badminton'),h1("Badminton Manager");

my $i=0;
my @teilnehmerDB=`cat teilnehmerDB`;
#
# teilnehmerDB: Nr, Status, Name, Vorname, TelG, TelP, Mobil, EMailG, EMailP
#
#   Status 0=inaktiv, 1=aktiv
#
# anmeldungDB: [AnmeldeStatus Teilnehmer 0], [AnmeldeStatus Teilnehmer 1]...
#

$textSaveButton = 'Speichern';
$textMailAllButton = 'Senden';
$textMailSubscribedButton = 'Senden';
$textNewsButton = 'Speichern';
$textAdminButton = 'Speichern';

$sb=param("savebutton") || "-";
$mab=param("mailallbutton") || "-";
$nb=param("newsbutton") || "-";
$ab=param("adminbutton") || "-";
$mas=param("mailallsubject") || "-";
$maa=param("mailallarea") || "-";
$msb=param("mailsubscribedbutton") || "-";
$mss=param("mailsubscribedsubject") || "-";
$msa=param("mailsubscribedarea") || "-";
$na=param("newsarea") || "-";
$aa=param("adminarea") || "-";
$detail=param("detail") || "-";
$log=param ("log") || "-";
$logyr=param ("logyr") || "-";
$email=param ("email") || "-";
$news=param ("news") || "-";
$admin=param ("admin") || "-";
$init=param ("init") || "-";

# ------------------------------------ NEWS -----------------------------------

# news vom file lesen
$filenews = `cat news`;

# news speichern
if ($nb eq $textNewsButton) {
  system "echo \"$na\" > news";
}

# news editieren
if ($news ne "-" || $nb eq $textNewsButton) {
  print h3('News editieren');

  print start_form();
    print  p(textarea('newsarea',$filenews,20,100));
    print  submit('newsbutton', $textNewsButton);
  print end_form();

  printSubFooter();
  exit 0;
}

# -----------------------------------  ADMIN  -----------------------------------

# teilnehmer vom file lesen
$fileadmin = `cat teilnehmerDB`;

# teilnehmer speichern
if ($ab eq $textAdminButton) {
  system "echo \"$aa\" > teilnehmerDB";
}

# news editieren
if ($admin ne "-" || $ab eq $textAdminButton) {
  print h3('Teilnehmer editieren');

  print start_form();
    print  p(textarea('adminarea',$fileadmin,30,100));
    print  p('Bemerkungen');
    print  '<ul><li>Nr,Status,Name,Vorname,TelG,TelP,Mobil,EMailG,EMailP';
    print  '<br>&nbsp;';
    print  '<li>Neue Eintraege hinten anfgen mit neuer Nummer (wegen Logfile)'."\n";
    print  '<li>Eintraege nicht loeschen, Status auf 0 setzen (wegen Logfile)'."\n";
    print  '<li>Keine Leerzeichen, keine Leerzeilen, keine Luecken'."\n";
    print  '<li>Keine Leerzeilen am Ende'."\n";
    print  '</ul><br>';
    print  submit('adminbutton', $textAdminButton);
  print end_form();

  printSubFooter();
  exit 0;
}


# ------------------------------------ LOGFILE -----------------------------------

# logfile ausgeben
if ($log ne "-") {
  print h3('Logfile der Anmeldungen');

  my %tookplace;
  my %summ;
  my %years;

  if ($log == -1 && $init ne "-") {$log=$init;}

  my @badmintonlog=`cat badminton.log`;
  print '<table >';
  for ($i=0;$i<=$#badmintonlog;$i++)
  {
     @badmintonlogEntry=split(/\,/,$badmintonlog[$i]);
     @now  = localtime();
     $nowyear = $now[5]+1900;
     @date = split(" ",`date -d\"$badmintonlogEntry[$0]\" \+'%d %m %Y'`);
     $years{$date[2]}=1;

     # header
     if ($i==0) {
       print "<tr>";
       print th(["Datum"]);
       for ($j=1;$j<=$#teilnehmerDB+1;$j++) {
         print th({-width=>25},["<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=$j&logyr=$logyr> $j </a>"]);
       }
       print th(["Total"]);
       print "</tr>";
     }

     if (($nowyear==$date[2] && $logyr eq "curr") || $logyr==$date[2] || $logyr eq "all"){

       # data
       print "<tr ", ($i%2==0) ? "bgcolor=#cbcbcb" : "", " >";
       print td({-align=>center},["$date[0].$date[1].$date[2]"]);
       $ctr = 0;
       for ($j=1;$j<=$#teilnehmerDB+1;$j++) {
         if (defined($badmintonlogEntry[$j])) { chomp $badmintonlogEntry[$j]; }
         if (defined($badmintonlogEntry[$j]) && $badmintonlogEntry[$j] ne '') {
           print "<td ", ($log==$j) ? "bgcolor=#CCFFFF" : "", " align=center>$badmintonlogEntry[$j]</td>";
         } else {
           print "<td ", ($log==$j) ? "bgcolor=#CCFFFF" : "", " align=center>0</td>";
         }
         if (defined($badmintonlogEntry[$j]) && $badmintonlogEntry[$j] eq "1") {
           $ctr++;
           $summ{$j}++;
         }
       }
       if ($ctr>=4) { $bgcolor="#CCFFCC"; } 
       elsif ($ctr>=2) { $bgcolor="#FFFFCC"; } 
       else { $bgcolor="#FFCCCC"; }
       print td({-align=>center, -bgcolor=>$bgcolor},[ $ctr."<font size=\"-2\">(".++$tookplace{$bgcolor}.")</font>" ]);
       print "</tr>";
     }

     # summary
     if ($i==$#badmintonlog) {
       print "<tr>";
       print th(["Summe"]);
       for ($j=1;$j<=$#teilnehmerDB+1;$j++) {
         print th({-width=>25},[ (exists($summ{$j})) ? $summ{$j} : '-' ]);
       }
       print "</tr>";
     }

  }
  print '</table>';

  print h3('Legende:');
  print '<table>';
  print Tr({-align=>LEFT},[th([Nummer,Name,Vorname])]);
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$i]);
    $j=$teilnehmerDBEntry[0]+1;
    if (defined($teilnehmerDBEntry[2])) {
      print "<tr ", ($log==$j) ? "bgcolor=#CCFFFF" : "", ">";      
      if ($teilnehmerDBEntry[1]==1) {
        print td([
          "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=$j&logyr=$logyr>$j</a>",
          "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&detail=$j>$teilnehmerDBEntry[2]</a>",
          $teilnehmerDBEntry[3]]);
      } else {
        print td([
          "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=$j&logyr=$logyr>$j</a>",
          "<span style=\"text-decoration: line-through;\">
            <a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&detail=$j>$teilnehmerDBEntry[2]</a>
          </span>",
          "<span style=\"text-decoration: line-through;\">$teilnehmerDBEntry[3]</span>"]);
      }
      print "</tr>";
    } else {
      print Tr({-align=>LEFT},[td([$j," "," "])]);
    }
  }

  print '</table>';

  print p();
  print "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=$log&logyr=all>Alle</a> ";
  print "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=$log&logyr=curr>Laufendes Jahr</a> ";
  foreach $year (keys %years) {
    print "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=$log&logyr=$year>$year</a> ";
  }
  printSubFooter();
  exit 0;
}

# ------------------------------------ DETAIL -----------------------------------

# personendaten ausgeben
if ($detail ne "-") {
  print h3('Persnliche Daten');
  @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$detail-1]);
  print '<table>';
  print Tr({-align=>LEFT},[td(["Status",$teilnehmerDBEntry[1] ? "Aktiv" : "Inaktiv"])]);
  print Tr({-align=>LEFT},[td(["Name",$teilnehmerDBEntry[2]])]);
  print Tr({-align=>LEFT},[td(["Vorname",$teilnehmerDBEntry[3]])]);
  print Tr({-align=>LEFT},[td(["Telefon Geschft",$teilnehmerDBEntry[4]])]);
  print Tr({-align=>LEFT},[td(["Telefon Privat",$teilnehmerDBEntry[5]])]);
  print Tr({-align=>LEFT},[td(["Telefon Mobil",$teilnehmerDBEntry[6]])]);
  print Tr({-align=>LEFT},[td(["EMail Geschft","<a class=\"badminton\" href=\"mailto:$teilnehmerDBEntry[7]\">$teilnehmerDBEntry[7]</a>"])]);
  print Tr({-align=>LEFT},[td(["EMail Privat","<a class=\"badminton\" href=\"mailto:$teilnehmerDBEntry[8]\">$teilnehmerDBEntry[8]</a>"])]);
  print Tr({-align=>LEFT},[td(["<a class=\"badminton\" href=\"$installPath/badminton.cgi?init=$init&log=$detail&logyr=curr\">Statistik</a>"])]);
  print '</table>';

  printSubFooter();
  print end_html;
  exit 0;
}

# ------------------------------------ EMAIL -----------------------------------

open (LCK, ">lock") or die ("can't create lock");
flock(LCK,4);

#anmeldungDB laden
my $anmeldungDB=`cat anmeldungDB`;
@anmeldungDBEntry=split(/\,/,$anmeldungDB);

# mail an Angemeldete senden
if ($msb eq $textMailSubscribedButton) {
  my $sendmail="";
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$i]);
    if ($anmeldungDBEntry[$i]==1) {
      chomp($teilnehmerDBEntry[7]);
      chomp($teilnehmerDBEntry[8]);
      $sendmail = $sendmail." ".$teilnehmerDBEntry[7]." ".$teilnehmerDBEntry[8];
    }
  }
  if ($sendmail ne "") {
    $mailer= Mail::Mailer->new('sendmail');
    $mailer->open({From => 'ruedihofer@gmx.ch', To => $sendmail, Subject => $mss}); 
    print $mailer $msa;
    $mailer->close();
  }
  print h4({-style=>'Color: red;'},"EMail an Angemeldete gesendet");
}

# mail an alle senden
if ($mab eq $textMailAllButton) {
  my $sendmail="";
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$i]);
    if ($teilnehmerDBEntry[1]==1) {
      chomp($teilnehmerDBEntry[7]);
      chomp($teilnehmerDBEntry[8]);
      $sendmail = $sendmail." ".$teilnehmerDBEntry[7]." ".$teilnehmerDBEntry[8];
    }
  }
  if ($sendmail ne "") {
    $mailer= Mail::Mailer->new('sendmail');
    $mailer->open({From => 'ruedihofer@gmx.ch', To => $sendmail, Subject => $mas});
    print $mailer $maa;
    $mailer->close();
  }
  print h4({-style=>'Color: red;'},"EMail an alle gesendet");
}

# email schreiben
if ($email ne "-" || $msb eq $textMailSubscribedButton || $mab eq $textMailAllButton) {
  print h3('EMail senden');

  print start_form();
    print  h3('EMail an Angemeldete senden:');
    print  p('Betreff:', textfield('mailsubscribedsubject','Badminton Manager - Manuelles EMail an Angemeldete',60,100));
    print  p(textarea('mailsubscribedarea','',5,60));
    print  submit('mailsubscribedbutton',$textMailSubscribedButton);

    print  h3('EMail an alle senden:');
    print  p('Betreff:', textfield('mailallsubject','Badminton Manager - Manuelles EMail an alle',60,100));
    print  p(textarea('mailallarea','',5,60));
    print  submit('mailallbutton', $textMailAllButton);
  print end_form();

  printSubFooter();
  close LCK;
  exit 0;
}

# ------------------------------------ MAIN -----------------------------------

# anmeldungDB speichern
if ($sb eq $textSaveButton) {
  system "echo -n \"\" > anmeldungDB";
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    my $value=param('cb'.$i) || "-";
    if ($value eq "on" ) {
      system "echo -n 1, >> anmeldungDB";
    } else {
     system "echo -n 0, >> anmeldungDB";
    }
  }
}

#anmeldungDB laden
my $anmeldungDB=`cat anmeldungDB`;
@anmeldungDBEntry=split(/\,/,$anmeldungDB);

# Main screen
print h3('News');
#$filenews =~ s/\n/<br>/g;
print p($filenews);

print h3('Anmeldungen fr nchsten Donnerstag');

if ($sb ne $textSaveButton) {
  print h4({-style=>'Color: green;'},"\'Speichern\' nicht vergessen!");
} else {
  print h4({-style=>'Color: red;'},"Daten gespeichert");
}

print start_form();

  print '<table>';
  print Tr({-align=>LEFT},[th([Name,Vorname,Anmeldungsstatus])]);
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$i]);
    $j=$teilnehmerDBEntry[0]+1;
    if ($teilnehmerDBEntry[1]==1) {
      if (lc($init) eq lc($teilnehmerDBEntry[2]) || lc($init) eq lc($teilnehmerDBEntry[3])) {
        $init = $j;
      }
      print "<tr align=left ", ($init==$j) ? "bgcolor=#CCFFFF" : "", ">"; 
      print td(["<a class=\"badminton\" href=$installPath/badminton.cgi?detail=$j>$teilnehmerDBEntry[2]</a>",
               $teilnehmerDBEntry[3],
               checkbox('cb'.$teilnehmerDBEntry[0],$anmeldungDBEntry[$i],'on','')]);
    }
    print "</tr>";
  }
  print '</table>';

  print  submit('savebutton',$textSaveButton);

print end_form();

print  p("<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&log=-1&logyr=curr>Logfile ansehen</a> | ".
         "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&email=1>EMail senden</a> | ".
         "<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init&news=1>News editieren</a>");

printFooter();

close LCK;
exit 0;

# ------------------------------------ HELPER -----------------------------------

sub printSubFooter{
  print p("<a class=\"badminton\" href=$installPath/badminton.cgi?init=$init>Zurck</a>");
  printFooter();
}

sub printFooter{
  print '<hr style="width: 100%; height: 1px;" noshade="noshade">';
  $cvs='\$Id: badminton.cgi,v 1.23 2004/03/21 14:34:36 hofer Exp $xx';
  @cvsfield=split(/ /,$cvs);
  print '<font size=-1>(c) '.$cvsfield[3].', <a class=\"badminton\" href="mailto:ruedihofer@gmx.ch">Ruedi Hofer</a>, V'.$cvsfield[2].'</font>';
  print end_html();
}

