#!/usr/bin/perl 
#
# Badminton Manager
# (c) 2003 Ruedi Hofer
#
# $Date: 2004/01/31 17:27:15 $ , $Revision: 1.11 $
#

use Mail::Mailer;
use Fcntl ':flock';
require 'config.pl';

# check input
if ($#ARGV != 0)
  {
    print "Usage: $0 [clear|maileinladung|mailangemeldete].\n";
    exit 0;
  }

$ARGV[0] = lc ($ARGV[0]);
$ARGV[0] =~ s/\s+$//;

open (LCK, ">lock") or die ("can't create lock");
flock(LCK,LOCK_EX);

my $i=0;
my @teilnehmerDB=`cat teilnehmerDB`;
my $anmeldungDB=`cat anmeldungDB`;
@anmeldungDBEntry=split(/\,/,$anmeldungDB);
#
# teilnehmerDB: Nr, Status, Name, Vorname, TelG, TelP, Mobil, EMailG, EMailP
#
#   Status 0=inaktiv, 1=aktiv
#
# anmeldungDB: [AnmeldeStatus Teilnehmer 0], [AnmeldeStatus Teilnehmer 1]...
#

if ($ARGV[0] eq "clear") {
  system "echo `date`,`cat anmeldungDB`  >> badminton.log";
  system "echo -n '' > anmeldungDB";
  if ($adminmail ne "") {
    $mailer= Mail::Mailer->new('sendmail');
    $mailer->open({From => 'ruedihofer@gmx.ch', To => $adminmail, Subject => "$adminsubject - Log cleared"});
    print $mailer "Log cleared";
    $mailer->close();
  }
}

# mail an alle senden
if ($ARGV[0] eq "maileinladung") {
  my $sendmail="";
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$i]);
    if ($teilnehmerDBEntry[1]==1) {
      chomp($teilnehmerDBEntry[7]);
      chomp($teilnehmerDBEntry[8]);
      $sendmail = $sendmail." ".$teilnehmerDBEntry[7]." ".$teilnehmerDBEntry[8];
    }
  }
  if ($sendmail ne "") {
    $mailer= Mail::Mailer->new('sendmail');
    $mailer->open({From => 'ruedihofer@gmx.ch', To => $sendmail, Subject => 'Badminton Manager - Einladung'});
    print $mailer $me;
    $mailer->close();
  }
}

# mail an angemeldete senden
if ($ARGV[0] eq "mailangemeldete") {
  $ma=$ma1;
  $sendmail="";
  $ctrAngemeldete=0;
  for ($i=0;$i<=$#teilnehmerDB;$i++)
  {
    @teilnehmerDBEntry=split(/\,/,$teilnehmerDB[$i]);
    if ($anmeldungDBEntry[$i]==1) {
      chomp($teilnehmerDBEntry[7]);
      chomp($teilnehmerDBEntry[8]);
      $sendmail = $sendmail." ".$teilnehmerDBEntry[7]." ".$teilnehmerDBEntry[8];
      $ma=$ma.$teilnehmerDBEntry[2]." ".$teilnehmerDBEntry[3]."\n";
      $ctrAngemeldete++;
    }
  }

  if ($ctrAngemeldete >= 4) {
    $ma=$ma.$ma2_2;
  } else {
    $ma=$ma.$ma2_1;
  }

  $ma=$ma.$ma3;

  if ($sendmail ne "") {
    $mailer= Mail::Mailer->new('sendmail');
    $mailer->open({From => 'ruedihofer@gmx.ch', To => $sendmail, Subject => "Badminton Manager - Einladung an $ctrAngemeldete Angemeldete"});
    print $mailer $ma;
    $mailer->close();
  }

  if ($adminmail ne "") {
    $mailer= Mail::Mailer->new('sendmail');
    $mailer->open({From => 'ruedihofer@gmx.ch', To => $adminmail, Subject => "$adminsubject - $ctrAngemeldete Angemeldete"});
    print $mailer $ma;
    $mailer->close();
  }
}

close LCK;

# $Date: 2004/01/31 17:27:15 $ , $Revision: 1.11 $
